%define oname   dose3
# Currently packaging a snapshot to build with newer ocaml.
%global commit0 2c1b8df9064d645fac273e3ca96b5c0d92bf6e9f
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})

Summary: Framework for managing distribution packages and their dependencies
Name:    ocaml-%{oname}
Version: 5.0.1
Release: %mkrel 4.20180821git.11
License: LGPLv2 with linking exception
Group:   Development/OCaml
Url:     http://www.mancoosi.org/software/
# Intentionaly not using the macros as if you don't change the number in the URL
# you get a tarball of the old version named as the new one
#Source0: https://gforge.inria.fr/frs/download.php/file/35465/dose3-4.2.tar.gz
Source0:       https://scm.gforge.inria.fr/anonscm/gitweb?p=dose/dose.git;a=snapshot;h=%{commit0};sf=tgz#/dose-%{shortcommit0}.tar.gz
# One remaining safe-string fix.
Patch0:        ocaml-dose3-safe-string.patch

# The option to enable debuginfo generation (-tag debug) was commented out
# in the Makefile, so comment it back in.
Patch2:        ocaml-dose3-makefile-debug.patch

# Debian patches:
# port ocaml-dose3 to ocaml-re >= 1.7.2
Patch3:        0018-Port-to-ocaml-re-1.7.patch

BuildRequires: ocaml-compiler
BuildRequires: ocaml-ocamlbuild
BuildRequires: ocaml-ocamlgraph-devel
BuildRequires: ocaml-findlib-devel
BuildRequires: ocaml-extlib-devel
BuildRequires: ocaml-pcre-devel
BuildRequires: ocaml-camlbz2-devel
BuildRequires: ocaml-expat-devel
BuildRequires: ocaml-benchmark-devel
BuildRequires: ocaml-curl-devel
BuildRequires: ocaml-xml-light-devel
BuildRequires: librpm-devel
BuildRequires: ocaml-re-devel
BuildRequires: ocaml-seq-devel
BuildRequires: ocaml-cudf-devel
BuildRequires: pkgconfig(libcurl)
BuildRequires: ocaml-cppo
BuildRequires: ocaml-camlzip-devel
BuildRequires: ocaml-ounit-devel
Requires: ocaml-extlib
Requires: ocaml-pcre
Requires: ocaml-camlbz2-devel
Requires: ocaml-camlzip-devel
Requires: ocaml-expat
Requires: ocaml-curl
Requires: ocaml-ounit
Requires: ocaml-ocamlgraph
Requires: ocaml-cudf
Requires: librpm-devel


%description
Dose3 is a framework made of several OCaml libraries for
managing distribution packages and their dependencies.

Though not tied to any particular distribution, dose3 constitutes a pool of
libraries which enable analyzing packages coming from various
distributions.

Besides basic functionalities for querying and setting package properties,
dose3 also implements algorithms for solving more complex problems
(monitoring package evolutions, correct and complete dependency resolution,
repository-wide uninstallability checks).

%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}
Requires: ocaml-extlib-devel
Requires: ocaml-pcre-devel
Requires: ocaml-expat-devel
Requires: ocaml-curl-devel
Requires: ocaml-ounit-devel
Requires: ocaml-ocamlgraph-devel
Requires: ocaml-cudf-devel

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%autosetup -p1 -n dose-%{shortcommit0} #dose3-%{version}

# I think we want to package the .cmx files if possible.
sed "s/*.cmx /*.cmxignore /g" -i Makefile
sed "s,*.cmxs,*.cmxs _build/doselibs/*.cmx,g" -i Makefile
sed "s,cmxa cmxs,cmx cmxa cmxs,g" -i Makefile.config.in

%build
%configure \
            --libdir=%{_libdir} \
            --with-xml \
            --with-curl \
            --with-ocamlgraph \
            --with-zip \
            --with-oUnit \
            --with-rpm4

make

%check
# Tests fail for some reason
# make test

%install
make install LIBDIR=%{buildroot}%{_libdir}/ocaml BINDIR=%{buildroot}%{_bindir}
rm -f %{buildroot}%{_libdir}/ocaml/dose3/*.{cm,}o
rm -f %{buildroot}%{_libdir}/ocaml/dose3/*.ml{.depends,}
cd doc/manpages
for man in *.?; do
    install -m644 $man -D %{buildroot}%{_mandir}/man1/$man
done
cd ../..
cp META %{buildroot}%{_libdir}/ocaml/dose3

# Fix dangling links
rm -f %{buildroot}%{_bindir}/rpmcheck
rm -f %{buildroot}%{_bindir}/debcheck
rm -f %{buildroot}%{_bindir}/eclipsecheck
ln -s %{_bindir}/distcheck %{buildroot}%{_bindir}/rpmcheck
ln -s %{_bindir}/distcheck %{buildroot}%{_bindir}/debcheck
ln -s %{_bindir}/distcheck %{buildroot}%{_bindir}/eclipsecheck

%files
%dir %{_libdir}/ocaml/dose3
%doc COPYING
%{_bindir}/apt-cudf
%{_bindir}/ceve
%{_bindir}/challenged
%{_bindir}/deb-buildcheck
%{_bindir}/deb-coinstall
%{_bindir}/debcheck
%{_bindir}/distcheck
%{_bindir}/eclipsecheck
%{_bindir}/outdated
%{_bindir}/rpmcheck
%{_mandir}/man1/apt-cudf.1*
%{_mandir}/man1/apt-cudf-get.8*
%{_mandir}/man1/apt-cudf.conf.5*
%{_mandir}/man1/ceve.1*
%{_mandir}/man1/challenged.1*
%{_mandir}/man1/deb-buildcheck.1*
%{_mandir}/man1/debcoinstall.1.*
%{_mandir}/man1/distcheck.1*
%{_mandir}/man1/outdated.1*
%{_mandir}/man1/smallworld.1*
%{_mandir}/man1/strongdeps.1*
%{_libdir}/ocaml/dose3/META
%{_libdir}/ocaml/dose3/*.cma
%{_libdir}/ocaml/dose3/*.cmi
%{_libdir}/ocaml/dose3/*.cmxs
%{_libdir}/ocaml/stublibs/*.so*

%files devel
%doc README.architecture TODO
%{_libdir}/ocaml/dose3/*.a
%{_libdir}/ocaml/dose3/*.cmx
%{_libdir}/ocaml/dose3/*.cmxa


%changelog
* Sun Jan 10 2021 pterjan <pterjan> 5.0.1-4.20180821git.11.mga8
+ Revision: 1670868
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 5.0.1-4.20180821git.10.mga8
+ Revision: 1551743
- Rebuild for ocaml 4.10.0 final

* Thu Feb 20 2020 umeabot <umeabot> 5.0.1-4.20180821git.9.mga8
+ Revision: 1545762
- Mageia 8 Mass Rebuild

* Wed Jan 29 2020 tv <tv> 5.0.1-4.20180821git.8.mga8
+ Revision: 1485236
- rebuild for ocaml-re

* Wed Jan 29 2020 tv <tv> 5.0.1-4.20180821git.7.mga8
+ Revision: 1485036
- BR ocaml-seq-devel
- fix requires ending in description since 2013... :-(
- BR ocaml-ocamlbuild thus fixing build
- rebuild for ocaml-4.10
+ wally <wally>
- replace deprecated %%configure2_5x

* Mon Sep 16 2019 tv <tv> 5.0.1-4.20180821git.6.mga8
+ Revision: 1441885
- rebuild for rpm-4.15

* Sat Mar 16 2019 daviddavid <daviddavid> 5.0.1-4.20180821git.5.mga7
+ Revision: 1377876
- rebuild for new ocaml-curl 0.8.2

* Thu Oct 25 2018 daviddavid <daviddavid> 5.0.1-4.20180821git.4.mga7
+ Revision: 1325213
- rebuild for new ocaml 4.07.1

* Tue Oct 02 2018 daviddavid <daviddavid> 5.0.1-4.20180821git.3.mga7
+ Revision: 1315956
- rebuild against current ocaml stack

* Sun Sep 23 2018 umeabot <umeabot> 5.0.1-4.20180821git.2.mga7
+ Revision: 1299861
- Mageia 7 Mass Rebuild

* Wed Aug 22 2018 daviddavid <daviddavid> 5.0.1-4.20180821git.1.mga7
+ Revision: 1253359
- update to newer SCM (git) checkout
- modify Makefile in prep section in order to install cmx files
- add debian patch to port it to ocaml-re >= 1.7.2

* Fri Jul 13 2018 daviddavid <daviddavid> 5.0.1-3.mga7
+ Revision: 1243400
- rebuild for new ocaml-extlib 1.7.5

* Sat Mar 24 2018 daviddavid <daviddavid> 5.0.1-2.mga7
+ Revision: 1211861
- rebuild for new ocaml-extlib 1.7.4

* Wed Jan 31 2018 tv <tv> 5.0.1-1.mga7
+ Revision: 1198271
- new release
- fix build
- disable bz2 binding (broken build)
- rebuild for new ocaml

* Fri Oct 06 2017 daviddavid <daviddavid> 4.2-6.mga7
+ Revision: 1169316
- rebuild for new ocaml-cudf 0.9

* Sat Sep 02 2017 daviddavid <daviddavid> 4.2-5.mga7
+ Revision: 1150641
- fix compilation flags thus fixing empty debugsourcefiles.list
+ tv <tv>
- rebuild for new rpm

* Tue Sep 27 2016 pterjan <pterjan> 4.2-4.mga6
+ Revision: 1057035
- Rebuild for changed signature in ocamlgraph

* Mon Sep 26 2016 pterjan <pterjan> 4.2-3.mga6
+ Revision: 1056325
- Rebuild for fix in ocaml

* Tue Feb 23 2016 pterjan <pterjan> 4.2-2.mga6
+ Revision: 977426
- Rebuild for new ocaml-re

* Mon Feb 08 2016 pterjan <pterjan> 4.2-1.mga6
+ Revision: 950714
- Fix file list
- Fix BuildRequires
- Really update to 4.2
- Update to 4.2

* Sun Sep 06 2015 tv <tv> 3.1.3-7.mga6
+ Revision: 873299
- rebuild with new rpm

* Wed Oct 15 2014 umeabot <umeabot> 3.1.3-6.mga5
+ Revision: 747103
- Second Mageia 5 Mass Rebuild

* Wed Oct 08 2014 tv <tv> 3.1.3-5.mga5
+ Revision: 737463
- patch 3 :fix build with rpm-4.12
- use %%autopatch
+ umeabot <umeabot>
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 3.1.3-4.mga4
+ Revision: 526533
- Mageia 4 Mass Rebuild

* Tue Jun 04 2013 malo <malo> 3.1.3-3.mga4
+ Revision: 437230
- add patch to fix manpage generation

* Sat Jan 12 2013 umeabot <umeabot> 3.1.3-2.mga3
+ Revision: 361288
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Jan 03 2013 malo <malo> 3.1.3-1.mga3
+ Revision: 338248
- new version 3.1.3

* Thu Jan 03 2013 malo <malo> 3.0.2-6.mga3
+ Revision: 338230
- add patch to fix build due to wrong ocamlbuild for-pack directive
+ tv <tv>
- rebuild for new rpm
+ blue_prawn <blue_prawn>
- patch to use extlib-1.5.3
- new rpm group for ocaml
- new rpm group for ocaml
+ fwang <fwang>
- rebuild for new pcre

* Fri Sep 14 2012 malo <malo> 3.0.2-2.mga3
+ Revision: 293883
- fix dangling links (mga#7448)

* Sun Sep 02 2012 malo <malo> 3.0.2-1.mga3
+ Revision: 287316
- new version 3.0.2
- add missing requires for the devel package

* Sat Aug 04 2012 malo <malo> 2.9.10-5.mga3
+ Revision: 278501
- fix requires and buildrequires

* Sun Jun 10 2012 tv <tv> 2.9.10-4.mga3
+ Revision: 259382
- rebuild for new rpm-4.10.0

* Sat Feb 18 2012 malo <malo> 2.9.10-3.mga2
+ Revision: 210169
- renaming requires to ocaml-cudf

* Fri Feb 17 2012 malo <malo> 2.9.10-2.mga2
+ Revision: 210100
- missing requires

* Tue Feb 07 2012 malo <malo> 2.9.10-1.mga2
+ Revision: 205652
- new version 2.9.10
- spec clean-up
- updated file install and list
- new version 2.9.9

* Thu Oct 27 2011 malo <malo> 2.9.8-1.mga2
+ Revision: 158716
- Missing BuildRequires
- new version 2.9.8
- spec rewrite

* Tue Apr 12 2011 ennael <ennael> 2.9.2-2.2457.2.mga1
+ Revision: 83709
- remove deps on dose2

* Tue Apr 12 2011 ennael <ennael> 2.9.2-2.2457.1.mga1
+ Revision: 83661
- fix release tag
- remove rpm5 patch
- clean mdv macros
- imported package ocaml-dose3

